package io.takima.agencymanagement.dao;

import io.takima.agencymanagement.model.Airport;
import io.takima.agencymanagement.model.Discount;
import io.takima.agencymanagement.model.Travel;
import io.takima.agencymanagement.model.User;

import java.time.Instant;
import java.util.*;

public class TravelDao {

    private final Map<Long, Travel> travels = Collections.synchronizedMap(new HashMap<>());

    public TravelDao() {
        addTravelsToMap();
    }

    public void save(Travel travel) {
        travels.put(travel.getId(), travel);
    }

    public Travel update(Travel travel) {
        if (travels.containsKey(travel.getId())) {
            travels.put(travel.getId(), travel);
            return travel;
        }
        return null;
    }

    public void delete(Long travelId) {
        travels.remove(travelId);
    }

    public Travel findById(Long travelId) {
        return travels.get(travelId);
    }

    public List<Travel> findAll() {
        return new ArrayList<>(travels.values());
    }

    public void addTravelsToMap() {
        List<Discount> emptyDiscountsList = new ArrayList<>();
        Queue<User> emptyWaitList = new LinkedList<>();
        Set<User> emptyParticipantsList = new HashSet<>();
        Set<User> participantsList = new HashSet<>();
        participantsList.add(new User(10, "Jean", "Michel", "j.m@gamil.com"));

        Travel travel1 = new Travel(1, "Trip to Paris", Instant.now(), Instant.now().plusSeconds(3600), Airport.NEW_YORK_NEWARK, Airport.PARIS_ORLY, "Paris",50, 500.0, emptyDiscountsList, emptyParticipantsList, emptyWaitList);
        Travel travel2 = new Travel(2, "Holiday in Tokyo", Instant.now(), Instant.now().plusSeconds(7200), Airport.PARIS_CHARLES_DE_GAULLE, Airport.TOKYO_HANEDA,"Tokyo", 40, 800.0, emptyDiscountsList, emptyParticipantsList, emptyWaitList);
        Travel travel3 = new Travel(3, "Exploring Rome", Instant.now(), Instant.now().plusSeconds(10800), Airport.TOKYO_NARITA, Airport.NEW_YORK_JFK, "New York", 30, 600.0, emptyDiscountsList, participantsList, emptyWaitList);

        travels.put(travel1.getId(), travel1);
        travels.put(travel2.getId(), travel2);
        travels.put(travel3.getId(), travel3);
    }
}
