package io.takima.agencymanagement.dao;

import io.takima.agencymanagement.model.User;

import java.util.*;

public class UserDao {

    public UserDao() {
        //add data
        addUsersToMap();
    }

    private final Map<Long, User> users = Collections.synchronizedMap(new HashMap<>());

    public void save(User user) {
        users.put(user.getId(), user);
    }

    public User update(User user) {
        if (users.containsKey(user.getId())) {
            users.put(user.getId(), user);
            return user;
        }
        return null;
    }

    public void delete(Long userId) {
        users.remove(userId);
    }

    public User findById(Long userId) {
        return users.get(userId);
    }

    public List<User> findAll() {
        return new ArrayList<>(users.values());
    }

    public void addUsersToMap() {
        User user1 = new User(1, "John", "Doe", "john@example.com");
        User user2 = new User(2, "Jane", "Smith", "jane@example.com");
        User user3 = new User(3, "Alice", "Johnson", "alice@example.com");
        User user4 = new User(4, "Bob", "Williams", "bob@example.com");
        User user5 = new User(5, "Eva", "Brown", "eva@example.com");

        users.put(user1.getId(), user1);
        users.put(user2.getId(), user2);
        users.put(user3.getId(), user3);
        users.put(user4.getId(), user4);
        users.put(user5.getId(), user5);
    }
}
