package io.takima.agencymanagement.mapper;

import io.takima.agencymanagement.model.Travel;
import io.takima.agencymanagement.presentation.responsedto.TravelResponseDto;
import io.takima.agencymanagement.utils.AirportManager;

import java.time.ZoneId;
import java.time.ZonedDateTime;

public class TravelDtoMapper {

    public static TravelResponseDto fromTravel(Travel travel) {
        ZonedDateTime zonedDepartureDate = travel.getDepartureDate()
                .atZone(ZoneId.of(AirportManager.timeZone.get(travel.getDepartureAirport())));
        ZonedDateTime zonedArrivalDate = travel.getDepartureDate()
                .atZone(ZoneId.of(AirportManager.timeZone.get(travel.getArrivalAirport())));

        return new TravelResponseDto(travel.getName(), travel.getDestination(), travel.getDepartureAirport(), travel.getArrivalAirport(), zonedDepartureDate, zonedArrivalDate, travel.getPrice());
    }
}
