package io.takima.agencymanagement.model;

import java.time.Instant;

public class HotelOffer extends Offer {
    private boolean isBreakfastIncluded;
    private int nbOfAvailableDays;

    public HotelOffer(
            long id,
            double score,
            String description,
            int nbOfReviews,
            boolean isBreakfastIncluded,
            int nbOfAvailableDays
    ) {
        super(id, score, description, nbOfReviews);
        this.isBreakfastIncluded = isBreakfastIncluded;
        this.nbOfAvailableDays = nbOfAvailableDays;
    }

    @Override
    public boolean isValid() {
        return super.isValid() &&
                nbOfAvailableDays > 0;
    }

    public String getDetails() {
        return "Le nombre de jours valaibles " +
                nbOfAvailableDays +
                ". Petit déjeuner est " +
                (isBreakfastIncluded ? "" : "non") +
                "inclu";
    }

}
