package io.takima.agencymanagement.model;

import java.time.Instant;

public abstract class Offer {
    protected long id;
    protected double score;
    protected String description;
    protected int nbOfReviews;
    protected abstract String getDetails();

    protected Offer(long id, double score, String description, int nbOfReviews) {
        this.id = id;
        this.score = score;
        this.description = description;
        this.nbOfReviews = nbOfReviews;
    }

    protected boolean isValid() {
        return score >= 0 &&
                score <= 5 &&
                description != null &&
                !description.isBlank() &&
                nbOfReviews >= 0;
    }

}
