package io.takima.agencymanagement.model;

import java.time.Instant;

public class RestaurentOffer extends Offer {
    private int nbOfStars;
    private int nbOfPerson;

    public RestaurentOffer(
            long id,
            double score,
            String description,
            int nbOfReviews,
            Instant expiration,
            int nbOfStars,
            int nbOfPerson
    ) {
        super(id, score, description, nbOfReviews);
        this.nbOfStars = nbOfStars;
        this.nbOfPerson = nbOfPerson;
    }

    @Override
    public boolean isValid() {
        return super.isValid() &&
                nbOfPerson > 0 &&
                nbOfStars >0;
    }

    public String getDetails() {
        return "La reservation est dans un restaurant de %d étoiles, pour %s personnes".formatted(nbOfStars, nbOfPerson);
    }

}
