package io.takima.agencymanagement.service;

import io.takima.agencymanagement.dao.UserDao;
import io.takima.agencymanagement.mapper.UserDtoMapper;
import io.takima.agencymanagement.model.User;
import io.takima.agencymanagement.presentation.responsedto.UserResponseDto;

import java.util.List;

import static io.takima.agencymanagement.mapper.UserDtoMapper.fromUser;

public class UserService {

    UserDao userDao = new UserDao();

    public UserResponseDto create(User user) {
        userDao.save(user);
        return fromUser(user);
    }

    public UserResponseDto update(User  user) {
        userDao.save(user);
        return fromUser(user);
    }

    public UserResponseDto delete(User  user) {
        userDao.save(user);
        return fromUser(user);
    }

    public UserResponseDto findById(Long id) {
        User  user = userDao.findById(id);
        return fromUser(user);
    }

    public List<UserResponseDto> findAll() {
        return userDao.findAll().stream()
                .map(UserDtoMapper::fromUser)
                .toList();

    }
}
